IND	EQU	00
RTCC	EQU	01
OPTIONf	EQU	01
PCL	EQU	02
STATUS	EQU	03
FSR	EQU	04
PORTA	EQU	5H
TRISA	EQU	5H
PORTB	EQU	6H
TRISB	EQU	6H
INTCON	EQU	0BH
CNTREG	EQU	10H	;[ƼȦs(Τۭq)
TEMP	EQU	11H
BITCNT	EQU	12H	;ΤȦs
BYTCNT	EQU	13H
SCANCDE	EQU	14H

BUFFER	EQU	20H
CLK	EQU	0	;74LS164 8} CLOCK
DAT	EQU	1	;74LS164 1,2} DATA IN
C	EQU	0
Z	EQU	2
W	EQU	0
F	EQU	1

	ORG	0
	GOTO	START
	ORG	4
DISPLAY	BCF	INTCON,2
	MOVLW	00000001B
	MOVWF	SCANCDE
	MOVLW	4
	MOVWF	BYTCNT
	MOVLW	BUFFER
	MOVWF	FSR
BYT4OUT	
	MOVF	IND,W
	MOVWF	TEMP
	MOVLW	00000000B
	MOVWF	PORTA
	CALL	SERLOUT
	MOVF	SCANCDE,W
	MOVWF	PORTA
	CALL	DELAY
	BCF	STATUS,C
	RLF	SCANCDE,F
	INCF	FSR,F
	DECFSZ	BYTCNT,F
	GOTO	BYT4OUT
	CLRF	RTCC
	RETFIE
			
START	BSF	STATUS,5	;mhɭ1
	CLRF	TRISA
	CLRF	TRISB
	MOVLW	00000100B	;PRESCALAR SETTING 1:32
	MOVWF	OPTIONf	;RTCC INTERNAL CKS
	BCF	STATUS,5	;m^ɭ0
	MOVLW	10100000B	;ENABLE RTCC INTERRUPT
	MOVWF	INTCON
	CLRF	RTCC
;INDIRECT
	MOVLW	BUFFER	;NwĦa}XgJWF
	MOVWF	FSR	;gJ
	MOVLW	0F9H	;'1' 
	MOVWF	IND
	INCF	FSR,F
	MOVLW	0A4H	;'2'
	MOVWF	IND
	INCF	FSR,F
	MOVLW	0B0H	;'3'
	MOVWF	IND
	INCF	FSR,F
	MOVLW	099H	;'4'
	MOVWF	IND
LOOP	GOTO	LOOP

SERLOUT	MOVLW	8	;H`{
	MOVWF	BITCNT	;b`e,NƦsJBIT_CNT
LOOP8	BCF	PORTB,DAT	;`}l,ڭ̥]Ĥ@O0
	RRF   	TEMP,F	;NTEMPk,Ĥ@l,Ci
	BTFSC	STATUS,C	;STATUS,C;p0hUyO
	BSF	PORTB,DAT	;N74LS164,DATm1;QpWy0
	BSF	PORTB,CLK	;DATǳƧ,eXɯ߰T
	BCF	PORTB,CLK	;ɯߨuOON,OFF
	DECFSZ	BITCNT,F	;BIT_CNT=BIT_CNT-1,p0Uy
	GOTO	LOOP8	;hLOOP8,`8짹
	RETURN

DELAY			;HU@ʿu@{,تO
	MOVLW	05H	;
	MOVWF	0DH	;sJΤHμȦs f0D
DLY1	MOVLW	0FFH	;s ffh Jwfu@
	MOVWF	0EH	;sJΤHμȦs f0E
DLY2	DECFSZ	0EH	;0E = 0E - 1,psLUy
	GOTO	DLY2	;h DLY2 (soyQL)
	DECFSZ	0DH	;0f = 0f - 1,psLUy
	GOTO	DLY1	;h DLY1 (soyQL)
	RETURN		;ʿ{즹
	END
